G-41. Bellman Ford Algorithm

แชร์
ฝัง
  • เผยแพร่เมื่อ 26 พ.ย. 2024

ความคิดเห็น •

  • @takeUforward
    @takeUforward  2 ปีที่แล้ว +97

    Let's continue the habit of commenting “understood” if you got the entire video. Please give it a like too, you don't 😞
    Do follow me on Instagram: striver_79

    • @KiranKumar-sb3ti
      @KiranKumar-sb3ti 5 หลายเดือนก่อน

      understood

    • @KUMARBISHWAJEET-iq6ym
      @KUMARBISHWAJEET-iq6ym 5 หลายเดือนก่อน

      Understood

    • @sribalajij4386
      @sribalajij4386 3 หลายเดือนก่อน

      Understood

    • @bhagatalisha
      @bhagatalisha 3 หลายเดือนก่อน

      Striver you are amazing, you need to worry, your supporters will keep on increasing, infact next gen of engineers will be brought up "only by you" 😄✨

    • @aditya-at_its_lowest
      @aditya-at_its_lowest 2 หลายเดือนก่อน

      understood

  • @EliasEH89
    @EliasEH89 9 หลายเดือนก่อน +18

    Thank u.
    Note: The Dijkstra's algorithm implemented in G-32 can handle any negative edges graph EXCEPT the following cases:
    1- Directed graph having any negative cycle (cycle with sum < 0)
    2- Undirected graph having any negative edge because the edge in undirected graph is by itself a cycle

    • @Mercer80
      @Mercer80 8 หลายเดือนก่อน +1

      What if graph is disconnected and negative cycle isnt reachable from source then your first point is false.

    • @shravani2922
      @shravani2922 6 หลายเดือนก่อน +1

      Your thought is right, my doubt is why not follow Dijkstras algorithm implemented in G-32 for directed graphs with no negative cycles. The time complexity is even less than Bellmanford algorithm. What is the use of Bellman ford algorithm?

    • @tasneemayham974
      @tasneemayham974 5 หลายเดือนก่อน

      @@Mercer80 I think we can apply a quick visited check? Like we did in the first lectures?

  • @harleenkaur7751
    @harleenkaur7751 ปีที่แล้ว +89

    Thanks Striver. Trust me, even in my paid course, they just simply explained the working of Dijkstra and Bellman without going into such detail. U r the best teacher.

    • @dharmvir2330
      @dharmvir2330 ปีที่แล้ว +9

      True , i am also here from a paid course , Someone believes it or not These explanations are way better than in a paid course.

    • @harshitrautela6585
      @harshitrautela6585 3 หลายเดือนก่อน

      @@dharmvir2330 So why did you take the paid course? Is there any advantage you can think of that the paid course is giving better than Striver(just curious to know)?

  • @akshaysoni3496
    @akshaysoni3496 ปีที่แล้ว +64

    Improve Time Complexity by exponential with just minor observation:
    Put int count =0; After the first loop & increment the value of count by 1 when the dist array will get updated and at the end of the second loop, if the value of count is not increased then directly return dist array. if no update in dist array happened that means we already calculate dist array, no need to do further iteration, In the worst case it does not have any impact, but for rest, it decreases TC a lot. It Reduce the number of iteration in Best & Average cases.

    • @srimanproductions8396
      @srimanproductions8396 ปีที่แล้ว +1

      this should be pinned

    • @amalkumar256
      @amalkumar256 ปีที่แล้ว

      I did the same thing.

    • @shivangisehgal
      @shivangisehgal ปีที่แล้ว

      exactly!

    • @nalingoyal881
      @nalingoyal881 9 หลายเดือนก่อน +1

      Is this case even possible? in a graph like this : a-> b-> c . if we have found smaller distance for a->b , we will surely find shorter distance for b->c in next iteration. Let me know if you think differently.

    • @dank7044
      @dank7044 5 หลายเดือนก่อน +1

      @@nalingoyal881 Bhai you would find smoller distance for c in the same iteration.

  • @mandarbhatye17
    @mandarbhatye17 2 ปีที่แล้ว +52

    Thanks

  • @mashfy6314
    @mashfy6314 ปีที่แล้ว +259

    This guy got superpower. Can be cast as a Marvel hero "The Explainer" .

    • @samarthagarwal6965
      @samarthagarwal6965 ปีที่แล้ว +22

      And we all guys as watchers 😂

    • @noobcoder6306
      @noobcoder6306 ปีที่แล้ว

      nice one

    • @noobcoder6306
      @noobcoder6306 ปีที่แล้ว +2

      @@samarthagarwal6965 already taken by the "Watcher"

    • @blutoo1363
      @blutoo1363 ปีที่แล้ว +9

      I think Striver is already a good enough superhero name

    • @amanasrani6405
      @amanasrani6405 5 หลายเดือนก่อน

      Wahi yr his teachings skills with so much of patiencee

  • @av21015
    @av21015 2 ปีที่แล้ว +10

    You explained it really well, If I was to trace this myself I would have sat for an entire day.

  • @tanyacharanpahadi158
    @tanyacharanpahadi158 6 หลายเดือนก่อน +4

    OMG! too much hype about bellman ford algorithm and this is what it is? WOW! you made it so simple. Thanks a ton striver!

  • @HarshnitePrasad
    @HarshnitePrasad ปีที่แล้ว +1

    Things i figured out :
    1. If you know a path to reach a node you can figure out the paths to reach nodes adjacent to it.
    2. why repeat n-1 times, every time you run through the edges you find a path to reach the node and the cost to reach it, if its better you update, incase the cost doesnt update you have been able to exhaust the minimum cost path.

  • @srinayclg390
    @srinayclg390 ปีที่แล้ว +28

    when u said "yes u r correct", my confidence became infinity❤

  • @naitikrathore3317
    @naitikrathore3317 2 ปีที่แล้ว +3

    2 din baad DAA ki paper hai and Bellman Ford aayega exam me, soch hi rha tha ki striver agr next video yhi upload kr de fir to mjaa hi aa jaye and aaj subh dekha BOOM!!

  • @GauravThinks
    @GauravThinks ปีที่แล้ว +12

    Question: why do we need N-1 iterations?
    Reason: Because we first of all set the source distance out ot all the N edges, now we have N-1 edges, to fill their distances w.r.t source, we need at max N-1 iterations for each Node.

  • @LokeshSharma-hm5jz
    @LokeshSharma-hm5jz ปีที่แล้ว +1

    understood, I dont know why i was afraid of this algo in explaining. You made it a butter.

  • @imajt5
    @imajt5 10 หลายเดือนก่อน +1

    Have watched multiple videos, but got the understanding from this explaination. Thanks

  • @jagannathan1014
    @jagannathan1014 ปีที่แล้ว +2

    Shortly, if N nodes, the node at the farthest level will be at

  • @arnabdebnath2425
    @arnabdebnath2425 2 ปีที่แล้ว +2

    Bhaiya nind se uth ke breakfast mai apka video khaneka Maza hi kuch Alag h…….
    Thank you so much bhaiya ….❤

  • @harshith4549
    @harshith4549 5 หลายเดือนก่อน

    We can also fit the negetive cycle check in the for loop with extending its range to V and checking if its the Vth iteration in relaxtion without writing repeated code. Also the best and worst cases can be improved by keeping a count of how many relaxations done in each iteration which signifies that if at any point no relaxation can be done then no further iteration is required bcoz there will be no change in distances further. Here's how its done:
    vector bellman_ford(int V, vector& edges, int S) {
    vector dist(V, 1e8);
    dist[S] = 0;
    for(int i = 1; i

  • @ashutoshkumargiri3194
    @ashutoshkumargiri3194 ปีที่แล้ว

    One of the best playlist of Graph on youtube bhaia you deserve more

  • @ashutoshpandey1639
    @ashutoshpandey1639 ปีที่แล้ว +2

    one thing should also be mentioned that if a graph on N nodes have cycle, then their is path exist having more than N - 1 edges from first to last node.
    By the way best explanation on TH-cam👌

  • @pranshu_awasthi
    @pranshu_awasthi 7 หลายเดือนก่อน +2

    Dijsktra's code which striver has taught works for negative edges , it just not works for Negative edge cycles. So all in all , it would work for DAG with positive / negative weights.

    • @tasneemayham974
      @tasneemayham974 5 หลายเดือนก่อน +1

      Of course, because Dijkstra doesn't work for negative edges in UNdirected grapsh: What if you have 0 - 1 with -1 weight? It will give TLE. But in directed, 0->1 with -1, 1 can never go back to 0 so the loop will not work.

    • @pranshu_awasthi
      @pranshu_awasthi 5 หลายเดือนก่อน +1

      @@tasneemayham974 That's what I said. It works for DAG.

  • @dhanashreegodase4445
    @dhanashreegodase4445 11 หลายเดือนก่อน +1

    thanks striver, you are the real gem

  • @coder6109
    @coder6109 7 หลายเดือนก่อน

    Imp when to apply - > when have -ve cycles, idea-> relax all the edges v-1 times , tc->(O(VE))

  • @tasneemayham974
    @tasneemayham974 5 หลายเดือนก่อน +1

    SUBSCRIBED FROM FIRST RECURSION LIST VIDEO, SIRE!!!! UNDERRRSSTOOODDDD

  • @user-zn3be9ik1x
    @user-zn3be9ik1x ปีที่แล้ว

    start the relaxation loop from i=1 to i

  • @mdyousufgazi4030
    @mdyousufgazi4030 ปีที่แล้ว

    the thought process is insane

  • @prateekshrivastava2802
    @prateekshrivastava2802 ปีที่แล้ว

    Best explaination of this algo till date !!

  • @stith_pragya
    @stith_pragya 11 หลายเดือนก่อน +2

    Thank You So Much for this wonderful video...........🙏🏻🙏🏻🙏🏻🙏🏻🙏🏻🙏🏻

  • @alessandrocamilleri1239
    @alessandrocamilleri1239 ปีที่แล้ว +1

    Top notch explanation as usual. I would have included an update flag to pre-empt unnecessary iterations.

  • @Curiousdev01
    @Curiousdev01 ปีที่แล้ว +4

    Amazing content sir !! ..... if I get a job will be because of you.🙂

  • @ayushsharma-bw5ch
    @ayushsharma-bw5ch ปีที่แล้ว +1

    we need to relax each edge for n - 1 times but in the code we are running loop for

    • @vishnubanjara5209
      @vishnubanjara5209 ปีที่แล้ว +6

      if we assume it 0 index based then V-2 is right and if we take it 1 based than simply run it for 1 less as V-1

    • @shreyanshagrawal3115
      @shreyanshagrawal3115 ปีที่แล้ว +3

      for(int i = 0; i < N; i++) : runs for N times ( 0 to N-1)
      for(int i = 0; i < N-1; i++) : runs for N-1 times ( 0 to N-2) - which is required

  • @newsbuster2194
    @newsbuster2194 ปีที่แล้ว +1

    Thanks for putting such kind of effort for us.

  • @CodeMode9313
    @CodeMode9313 ปีที่แล้ว

    Habibi ye ek number bideo bana di tumne toh ...baut baut danyawaad

  • @keshavprasad1017
    @keshavprasad1017 6 หลายเดือนก่อน

    thank you so much for the clean and crisp explanation.

  • @decepticonWave
    @decepticonWave ปีที่แล้ว +3

    The fact that you explained N-1 is why you are the GOAT. Please make a paid course and we will pay

    • @ashutoshpandey1639
      @ashutoshpandey1639 ปีที่แล้ว

      But the one thing should also be mentioned that if a graph on N nodes have cycle then their is path exist having edges more than N - 1.

  • @amankush2408
    @amankush2408 5 หลายเดือนก่อน

    Understood. Great explanation for the intuition.

  • @divyareddy7622
    @divyareddy7622 หลายเดือนก่อน +1

    takeaway: having n-1 iterations, helps bellman ford to avoid infinite loop. It won't again try to find a better distance.

  • @rithikraj4316
    @rithikraj4316 4 หลายเดือนก่อน

    Simple in every cycle worst can be 1 updation, so we need to update n - 1 updation as we already have 0 or src updated manually

  • @cinime
    @cinime 2 ปีที่แล้ว +1

    Understood! Super amazing explanation as always, thank you very much!!

  • @Chirayu19
    @Chirayu19 ปีที่แล้ว

    You got so much energy, bro!

  • @Kparkhade
    @Kparkhade 4 หลายเดือนก่อน

    Maja aa gaya
    Itna khatarnak explanation bro 🎉

  • @AyushiPanday12
    @AyushiPanday12 ปีที่แล้ว

    Thanks Striver for these wonderful lectures. Understood.

  • @CodeNow-nc4rk
    @CodeNow-nc4rk 2 หลายเดือนก่อน

    23:34 -
    If someone is wondering like me as to why the edges are passed by reference using &
    If you don't use a reference, the function would create a copy of the edges vector every time the function is called, which can be very costly in terms of memory and time, especially for large graphs

  • @priyapandey8951
    @priyapandey8951 หลายเดือนก่อน

    I just wanted to play around with dijkstra and I know this in not an optimal solution and thought of doing the negative cycle part with dijsktra only. My thought process is very simple with djkstra also you could solve the problem the only issue was negative cycle. Now a cycle in itself is not an issue but a cycle with reducing distance does. According to the condition of dijkstra it would enter the if block if we get a decreasing distance and this will only happen in negative cycle or in linear path. To check that we can store paths for each node. Next time we visit that node we check do we already have the node itself in the path that means we are in a cycle or else there is a different path that led us to the node.
    Code:
    vector bellman_ford(int V, vector& edges, int S) {
    // Code here
    vector adj(V);
    for(int i=0;i

  • @kaichang8186
    @kaichang8186 2 หลายเดือนก่อน

    understood, thanks for the intuition part

  • @udaytewary3809
    @udaytewary3809 ปีที่แล้ว

    Understood bhaiya 🙏❤️

  • @virgarg9653
    @virgarg9653 ปีที่แล้ว

    Beautiful Explanation . Loved your content keep going 100%

  • @vakhariyajay2224
    @vakhariyajay2224 ปีที่แล้ว +1

    Thank you very much. You are a genius.

  • @sdfg204
    @sdfg204 8 หลายเดือนก่อน

    Had no idea it was this easy, damn. Obviously now that i know the logic, i don't even need to remember it.

  • @120-venkataraghavareddyvar4
    @120-venkataraghavareddyvar4 ปีที่แล้ว +1

    I guess for the question why we need to do n-1 relaxations to each node is that ,, suppose we have 3 nodes directly connected a node and we have relaxed those nodes,, now in typical dijkstra algo,, the node with smallest value of relaxation will never get relaxed again, but if there are negative weights,, then there is a chance that the the node with smallest value of relaxation will get relaxed again. Since each node at max gets connected to n-1 nodes, so thus n-1 relaxations.

  • @komalkrishna7836
    @komalkrishna7836 2 ปีที่แล้ว

    Wow! very well explained, completely Understood

  • @Stickman-rz9nu
    @Stickman-rz9nu 6 หลายเดือนก่อน

    bhaiya , in the for loop terminating condition should be “ i < V “ for n-1 iterations

  • @VrundLeuva-g5s
    @VrundLeuva-g5s 4 หลายเดือนก่อน

    very nice explanation

  • @rajeshj4066
    @rajeshj4066 ปีที่แล้ว +1

    @ 16:00 : explained why it has n-1 iterations

  • @KurumiddeKezia
    @KurumiddeKezia 15 วันที่ผ่านมา

    tq striver bhaiyya

  • @lokeshroy3944
    @lokeshroy3944 ปีที่แล้ว

    intution was just 🔥🔥🔥🔥🔥🔥🔥🔥

  • @vaalarivan_p
    @vaalarivan_p ปีที่แล้ว +1

    5:28 - 22:00

  • @kiranpoojary493
    @kiranpoojary493 หลายเดือนก่อน

    20:11 activated SUPER SONIC MODE 🔥

  • @g51661
    @g51661 ปีที่แล้ว

    Thank you, Striver!
    Understood

  • @rajatjakhar3146
    @rajatjakhar3146 ปีที่แล้ว +1

    great explanation 🔥🔥🔥🔥

  • @herculean6748
    @herculean6748 ปีที่แล้ว

    lots of love and respect🙌

  • @kirankuyate6056
    @kirankuyate6056 ปีที่แล้ว

    greate explaination and with great energy while explaining that make people more creative affracting getting more..💖

  • @UtpalPodder-IITian
    @UtpalPodder-IITian 5 หลายเดือนก่อน

    Presense of negative edge does not always result incorrect result ...that could be easily proved in the second example if there is a path say from 4 to 3 with -1 edge weight ....but if the negative edge cycle change the previous path length which we got after n-1 iteration then it cause problem.

  • @dipendrapratap6495
    @dipendrapratap6495 2 หลายเดือนก่อน

    If we will take nodes in a increasing order then that time I think we can find the distance in 2-3 iteration as well we don't need to do n-1 iterations

  • @suyashjain3223
    @suyashjain3223 9 หลายเดือนก่อน

    Amazing Explanation!!🔥🔥

  • @juniorboy1903
    @juniorboy1903 2 ปีที่แล้ว +1

    Understood😉 bhaiya

  • @kushalkollu8628
    @kushalkollu8628 3 หลายเดือนก่อน

    striver bhai is goated

  • @varunakrishnani7688
    @varunakrishnani7688 ปีที่แล้ว +1

    Understood!! :)
    Thank you! 🙏🏻😊

  • @Kokowangmini
    @Kokowangmini ปีที่แล้ว +1

    understood, It was so Awesome.

  • @smile8510
    @smile8510 2 ปีที่แล้ว +2

    Master piece !

  • @ankitpandey7262
    @ankitpandey7262 2 ปีที่แล้ว

    Understood !! Amazing as always

  • @auroshisray9140
    @auroshisray9140 ปีที่แล้ว

    Well explained bhai!

  • @sallaklamhayyen9876
    @sallaklamhayyen9876 6 หลายเดือนก่อน

    great explanation thank you so much and please continue😘😍

  • @MojnoSardar
    @MojnoSardar ปีที่แล้ว

    Very well explained.

  • @aryashjain7893
    @aryashjain7893 2 ปีที่แล้ว

    watching it at 4 a.m. and when u say , I got a better guy, it really hurts :)🤣🤣

  • @vyomyadav6497
    @vyomyadav6497 ปีที่แล้ว

    Good, well explained.

  • @saniyaverma914
    @saniyaverma914 6 หลายเดือนก่อน

    Understood, thank you bhaiya

  • @stark2461
    @stark2461 ปีที่แล้ว

    In Case of Negative weight cycles, Dijkstra don't run forever. It produces wrong answer

  • @chitranshkulshrestha485
    @chitranshkulshrestha485 4 หลายเดือนก่อน

    Thanks for the intution

  • @asktostranger8296
    @asktostranger8296 2 ปีที่แล้ว +1

    Bahi abhi graph ki kitni video he
    Aur bachi
    He
    Big fan 😍🙏

  • @Learnprogramming-q7f
    @Learnprogramming-q7f 6 หลายเดือนก่อน

    Thank you bhaiya

  • @UECAshutoshKumar
    @UECAshutoshKumar 11 หลายเดือนก่อน +1

    Thank you sir 🙏

  • @NAYANPATELTECH
    @NAYANPATELTECH 11 หลายเดือนก่อน

    Super explanation😀

  • @soninirav
    @soninirav 2 ปีที่แล้ว

    Amazing , very well explained 🔥🔥

  • @maneeshapanu
    @maneeshapanu ปีที่แล้ว

    The best explanation doesn't exist.. Meanwhile Striver : Hold my beer 😵
    Thank you so much 🙏🙏

  • @kr_ankit123
    @kr_ankit123 2 ปีที่แล้ว +1

    Understood👍👍
    Thanks a lot

  • @SmitShah-m1m
    @SmitShah-m1m ปีที่แล้ว

    Understood Sir

  • @parshchoradia9909
    @parshchoradia9909 ปีที่แล้ว

    Understood Sir!

  • @psurya3053
    @psurya3053 2 ปีที่แล้ว +1

    thank you bhaiyya , please can you make a playlist on examples on segment trees from codeforces

  • @KaushikSharma-c3q
    @KaushikSharma-c3q 3 หลายเดือนก่อน

    understood too

  • @sambhavagarwal5871
    @sambhavagarwal5871 2 ปีที่แล้ว

    understood striver

  • @doingsneakypeakylike
    @doingsneakypeakylike 2 ปีที่แล้ว

    Solid explanation man! Thanks!

  • @niharikakumar1533
    @niharikakumar1533 ปีที่แล้ว

    Understood sir 🙂

  • @YourITGuy9
    @YourITGuy9 2 ปีที่แล้ว +2

    at 17.25 Edges are 5 i think u r referring to the no of nodes not edges

  • @cricketguru7596
    @cricketguru7596 ปีที่แล้ว

    clear explanation

  • @dipanshumahto9520
    @dipanshumahto9520 ปีที่แล้ว

    baad m distance array ka sum nikal k check kr skte h n negative cycle ka
    for(int i=0;i

  • @TanishqAnand
    @TanishqAnand 2 ปีที่แล้ว

    Understood Raj bro

  • @kasireddyasam9143
    @kasireddyasam9143 ปีที่แล้ว

    undershood sir

  • @sambhavgandhi6553
    @sambhavgandhi6553 ปีที่แล้ว

  • @Alwaysalearner123
    @Alwaysalearner123 ปีที่แล้ว

    In for loop i

  • @googleit2490
    @googleit2490 ปีที่แล้ว

    Understood :)
    Sep'2, 2023 11:38 am